/* create a parallel branch process with pipe for background updates, etc. */

#include <stdio.h>
#include <errenv.h>
#include <bmslib.h>
#include <unistd.h>
#include <stdlib.h>

int branch(const char *prognam,MORE) {
  int pipedes[2], res;
  if (pipe(pipedes))
    errpost(errno);		/* signal branch error */
  if ( (res = fork()) < 0 )
    errpost(errno);
  if (res == 0)			/* if child */
  { int rc;
    close(pipedes[1]);
    close(0);			/* close std input */
    dup(pipedes[0]);
    close(pipedes[0]);
    /* non-portable, but works on machines with standard stack protocol */
    execvp(prognam,&prognam);	/* chain to branch program */
    rc = errno;
    envelope
      errvdesc(rc,"Can't exec program %s",prognam);
    envend
    exit(1);
  }
  close(pipedes[0]);
  return pipedes[1];
}
