/*
Program:   stoJ.c Revision:  1.1 as of 4/18/91
Date:      04/11/90
Author:	   Ed Bond
Function:  stoJ.c - String to JULDAY.
Copyright (c) 1990 Business Management Systems, Inc.
*/

#include <date.h>
#include <money.h>

JULDAY stoJ(s)
  const char *s;
{
  long mdydate;
  struct mmddyy mdy;

  mdydate = stol("ZZ/ZZ/ZZZZ",s,0);
  if (mdydate == 0L) return zeroJ;
  decode(&mdy,mdydate);
  return julian(&mdy);
}
