#include <block.h>

int lpad(data,len)
  char *data;
  int len;
{
  register int n;
  n = blkfntl(data+len,' ',len);	/* n is number of chars */
  if (n >= len) return 0;
  blkmovl(data+len,data+n,n);		/* shift data to right */
  blkfilr(data,' ',len-n);		/* add blanks on left */
  return len;
}

int rpad(data,len)
char *data;
int len;
{
  register int n;
  len -= (n = blkfntr(data,' ',len));
  if (len==0) return 0;
  blkmovr(data,data+n,len);
  blkfilr(data+len,' ',n);
  return blkfntl(data+len,' ',len);
}

int center(data,len) 
char *data;
int len;
{
  register int lead;
  register int beg,end,n;
  beg = blkfntr(data,' ',len);	/* first non-blank */
  end = blkfntl(data+len,' ',len);	/* last non-blank */
  n = (end - beg);		/* non - blank text */
  lead = (len - n)/2;		/* leading blanks desired */
  if (beg>len-end)		/* if more space at beginning */
    return rpad(data + lead,len - lead);
  else
    return lpad(data,n+lead);
}
