static char what[] = "@(#)strtomny.c	1.9";
/* convert formatted or unformatted string to money */
/* alb - 11/10/84 */

#include <money.h>
#include <string.h>

#define TRUE 1
#define FALSE 0
#define PLUS 1
#define MINUS -1
#define find(a,b)	strchr(b,a)

long stol(mask,txt,fix)
  const char *mask, *txt;
  int fix;
{
  MONEY num;
  strtomny(mask,txt,&num,fix);
  return (num.high << 16) + num.low;
}

MONEY *strtomny(mask,txt,num,fix) 
  const char *mask, *txt;
  MONEY *num;
  int fix;
{
  register char *cp;
  register const char *mp;
  register int decpt = FALSE;
  register int sign = PLUS;
  char legal[20];

  *num = zeroM;
	
/* find fix from mask if zero */

  if (fix == 0) {
    mp = mask;
    while (*mp) {
      if (*mp++ == '.') decpt = TRUE;
      else if ((decpt == TRUE) && find(mp[-1],"zZ#")) fix++;
    }
  }

/* build legal from mask.  Ignore "zZ#.+". */
  cp = legal; mp = mask;
  while (*mp) 
  {
    if (!find(*mp++, "zZ#.+"))
      *cp++ = mp[-1];
  }
  *cp = '\0';

/* Convert number, ignoring all characters in mask except "zZ#.+-".  
   If "." found, set decpt.  If non-mask character found, terminate
   scan.  Ignore leading blanks.					*/

  /* skip leading blanks */
  while (*txt++ == ' ');
  txt--; 			/* correct overshoot */

  /* check for "-" in first non-blank position */
  if (*txt == '-') 
  {
    sign = MINUS; 
    txt++;
  }

/* scan until separator encountered */
  decpt = FALSE;
  while ((*txt) && (fix >= 0)) 
  {
    if (*txt == '.') decpt = TRUE;
    else if ((*txt >= '0') && (*txt <= '9')) 
    {
      if ((decpt == TRUE) && ((fix--) <= 0)) break;
      mulmoney(num,10,*txt-'0');
    }
    else if (!find(*txt,legal)) break;

    txt++;
  }

  /* check for "-" in last position */
  if (*(txt-1) == '-') sign = MINUS;

  /* adjust sign */
  mulmoney(num,sign,0);

  /* adjust fix */
  while (fix > 0) 
  {
    mulmoney(num,10,0);
    fix--;
  }

  return num;
}
