#include <port.h>
/* TSEARCH(3C) */
typedef enum { preorder, postorder, endorder, leaf } VISIT;
typedef struct tree *TREE;

extern PTR *tsearch(const PTR, TREE *,	/* NOTE, AT&T manual lies ... */
	int (*)(const PTR, const PTR));
extern PTR tfind(const PTR, const TREE *,
	int (*)(const PTR, const PTR));
extern PTR tdelete(const PTR, TREE *,
	int (*)(const PTR, const PTR));
extern void twalk(TREE, void (*)(void **, VISIT, int));

/* BMS extensions */
extern void tsort(TREE, void (*)(PTR));
extern void tclear(TREE *, void (*)(PTR));
#define tadd(a,b,c) (*tsearch(a,b,c))

