#include <port.h>
#include <string.h>

#define ldstr(d,l,s)	stchar(s,d,l)
#define blkmovr(d,s,l) ((void)memcpy(d,s,l))
#define blkfilr(d,c,l) ((void)memset(d,c,l))

extern int blkcmpr(/**/ const char *,const char *,int /**/);
extern int blkfndl(/**/ const char *,int,int /**/);
extern int blkfndr(/**/ const char *,int,int /**/);
extern int blkfntl(/**/ const char *,int,int /**/);
extern int blkfntr(/**/ const char *,int,int /**/);
extern int blkcmp(/**/ const unsigned char *, const unsigned char *, int /**/);
extern void blkmovl(/**/ char *, const char *, int /**/);
extern void rotate(/**/ char *, int, int /**/);
extern void swap(/**/ char *, char *, int /**/);
extern int seteos(/**/ char *,int,int /**/);
extern int lpad(char *,int),rpad(char *,int),center(char *,int);
extern char *ultoa(unsigned long x,char *buf,int radix);
extern char *ltoa(long x,char *buf,int radix);

#define move(d,s)	blkmovr((char *)(d),(char *)(s),sizeof(d))
#define clear(d,c)	blkfilr((char *)(d),c,sizeof(d))
#define clears(d,c)	blkfilr((char *)(&d),c,sizeof(d))
#ifndef count
#define count(array)	(sizeof array/sizeof array[0])
#endif
#define all(a,c)	(blkfntr((char *)(a),c,sizeof(a)) == sizeof(a))
#define cmp(a,b)	blkcmpr((char *)(a),(char *)(b),sizeof(a))
#define isblank(d)	all(d,' ')
#define isnblank(d)	(!all(d,' '))
#define isequal(a,b)	(cmp(a,b) == 0)
#define isnequal(a,b)	cmp(a,b)
#define isgt(a,b)	(cmp(a,b) > 0)
#define isgteq(a,b)     (cmp(a,b) >= 0)
#define islt(a,b)	(cmp(a,b) < 0)
#define islteq(a,b)     (cmp(a,b) <= 0)
#define isfound(d,c)	all(d,c)
#define isnfound(d,c)	(!all(d,c))
