#include <stdio.h>
#include <stdlib.h>
#include <bmsargs.h>

int bmsargs(argc,argv,tbl,cnt,options)
  int argc, cnt;
  char **argv; const char *options;
  const struct argtbl *tbl;
{
  register int i;
  register const struct argtbl *p;
  register int c;
  extern char *optarg;
  while ((c = getopt(argc,argv,options)) != EOF) {
    for (i=0,p=tbl;; p++) {
      if (++i>cnt) return 1;
      if (c == p->flag) {
	if (p->type) {
	  if ((*p->type)(p->var,optarg)) {	/* convert argument */
	    return 1;
	  }
	}
	else
	  *p->var = 1;			/* set flag true */
	break;
      }
    }
  }
  return 0;
}

argstr(dst,src)
  PTR dst;
  const char *src;
{
  *(const char **)dst = src;
  return 0;
}

argint(dst,src)           
  PTR dst;
  const char *src;          
{                          
  *(short *)dst = atol(src);
  return 0;
}

argshort(dst,src)            /* added by C. Gray  1/10/89  */
  PTR dst;
  const char *src;
{
  *(short *)dst = atol(src);
  return 0;
}

arglong(dst,src)
 PTR dst;
 const char *src;
{
  *(long *)dst = atol(src);
  return 0;
}

argchar(dst,src)
 PTR dst;
 const char *src;
{
  *(char *)dst = *src;
  return 0;
}
