static char what[] = "%W%";
/*
   input restricted deque
*/

#include "deque.h"
extern char *malloc();

#define head (*q)
#define MEMCNT 10	/* allocate this many nodes at once */
static qnode *freeq;

nextq(q,data)
  char *data;
  qnode **q;
{
  register qnode *p = freeq;
  if (p == 0) {
    int i;
    p = (qnode *)malloc(sizeof(qnode) * MEMCNT);
    if (p == 0) return 1;		/* out of memory */
    for (i = 0; i < MEMCNT - 1; ++i) {
      p->nxt = freeq;
      freeq = p++;
    }
    /* we'll use the last one */
  }
  else
    freeq = p->nxt;
  p->data = data;
  if (head) {
    head->prv->nxt = p;
    p->prv = head->prv;
  }
  else {
    head = p;
  }
  p->nxt = head;
  head->prv = p;
  return 0;
}

char *delq(q,flag)	/* flag true for firstq */
  qnode **q;
{
  register qnode *p = head;
  if (p == 0) return 0;
  if (flag)
    head = p->nxt;
  else
    p = p->prv;
  if (p == head)
    head = 0;
  else {
    p->prv->nxt = head;
    head->prv = p->prv;
  }
  p->nxt = freeq; freeq = p; 
  return p->data;
}
