#include "ebcdic.h"

int ldebstr(str,ebstr,len)
  char *str;
  const unsigned char far *ebstr;
  int len;
{
  register char *s = str;
  while (len && ebstr[len - 1] == 0x40) --len;
  while (len-- > 0) {
    *s++ = ebcdic(*ebstr++);
  }
  *s = 0;
  return s - str;
}

void stebstr(str,ebstr,len)
  const char *str;
  unsigned char far *ebstr;
  int len;
{
  while (*str && len-- > 0) {
    *ebstr++ = ascii(*str++);
  }
  while (len-- > 0) *ebstr++ = 0x40;
}
