/*
Program:   stoD.c Revision:  1.1 as of 4/18/91
Date:      04/05/90
Author:	   Ed Bond
Function:  stoD.c - String to DATE.
Copyright (c) 1990 Business Management Systems, Inc.
*/

#include <date.h>
#include <money.h>

DATE stoD(s)
  const char *s;
{
  long mdydate;
  struct mmddyy mdy;

  mdydate = stol("ZZ/ZZ/ZZ",s,0);
  if (mdydate == 0L) return zeroD;
  decode(&mdy,mdydate);
  return mdy_to_doc(mdy);
}
