/*
This routine allows you to scan a string for a substring.  If found, the 
offset into the major string is returned.  This routine is not optimzed for
quick sub-string searches, it uses a straight left to right search technique.
*/
#include <bmslib.h>

int strnfndr(a,b,c,d)
  const char *a, *b;
  int c,d;
{ int rtnval= -1, ctr=0, offset=0;
  if((d==0)||(c==0)) return -1;
  for(;;)
    {
    if(ctr==d) 
      { /* match found */
      rtnval=offset;
      break;
      }
    if(offset>=c) break; /* no match found */
    if(*(a+offset+ctr)== *(b+ctr))
      { /* look for next character */
      ctr++;
      }
    else /* match not found */
      {
      offset+=(ctr+1);
      ctr=0;
      }
    }
  return rtnval;
}
