/* same args as strncmp.
   compare two strings, case insensitive.
*/
#include <string.h>
#include <ctype.h>

int strnicmp(s1,s2,len)
  const char *s1, *s2;
  int len;
{
  while (len--) {
    register int c1 = *(unsigned char *)s1++, c2 = *(unsigned char *)s2++;
    if (islower(c1)) c1 = _toupper(c1);
    if (islower(c2)) c2 = _toupper(c2);
    if (c1 == 0 || c1 != c2) return c1 - c2;
  }
  return 0;
}
