#include "tree.h"

static void (*userf)(PTR *,VISIT,int);
static short level;

static void twalk_help(struct treenode *p) {
  if (p->llink || p->rlink) {
    (*userf)(&p->data,preorder,level);
    ++level;	/* next level */
    if (p->llink) twalk_help(p->llink);
    (*userf)(&p->data,postorder,level-1);
    if (p->rlink) twalk_help(p->rlink);
    --level;	/* restore level */
    (*userf)(&p->data,endorder,level);
  }
  else
    (*userf)(&p->data,leaf,level);
}

void twalk(TREE root,void (*action)(PTR *,VISIT,int)) {
  if (root) {
    level = 0;
    userf = action;
    twalk_help(root->root);
  }
}
